﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;

namespace Property.Workers
{
    public partial class TimeoutFunctionWorkerDecoratorPrototype<T> : FunctionWorkerDecoratorPrototype<T>, IFunctionWorkerPrototype<T>
    {
        public TimeoutFunctionWorkerDecoratorPrototype(IFunctionWorkerPrototype<T> compositionBasePrototype, ITimerPrototype timerPrototype)
            : base(compositionBasePrototype)
        {
            _TimerPrototype = timerPrototype;
        }

        //=//

        private readonly ITimerPrototype _TimerPrototype;

        public override IWorker Create(Func<T> getValue)
        {
            return new DecoratorInstance(_CompositionBasePrototype, getValue, _TimerPrototype);
        }
    }
}
