﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;

namespace Property.Subscriptions
{
    public abstract class ActionSubscription<T> : Subscription<T>
    {
        public ActionSubscription(IProperty<T> property, Action action)
            : base(property)
        {
            if (action == null) throw new ArgumentNullException("action");

            _Action = action;
        }

        //=//

        protected readonly Action _Action;
    }
}

