﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using System.Collections.Generic;

namespace Property.Objects
{
    public partial class CheckInputPropertyPrototype<T> : DecoupledPropertyPrototype<T>, ICheckInputPropertyPrototype<T>
    {
        public CheckInputPropertyPrototype(IReloaderPrototype<T> reloaderPrototype, Func<T, string> check)
            : base(reloaderPrototype)
        {
            _Check = check;
        }

        //=//

        protected readonly Func<T, string> _Check;

        public ICheckInputProperty<T> Create(T defaultValue)
        {
            return new PropertyInstance(_ReloaderPrototype, _Check, defaultValue);
        }
    }
}
