﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using Property.Objects;
using System;
using System.Collections.Generic;

namespace Property.Windows.Legacy
{
    /// <summary>
    /// Contains words that extend the description 
    /// of a property's reload process.
    /// </summary>
    public static class ReloaderPrototypeExtensionsWindowsLegacy
    {
        /// <summary>
        /// <para>... the user sets the property's Input.</para>
        /// <para>A new property value will be read from Input.</para>
        /// <para>( i ) IDataErrorInfo will be used to check the value.</para>
        /// </summary>
        /// <param name="check">Tell me what message to show
        /// for a given value.</param>
        public static ICheckInputPropertyPrototype<T> CheckInput<T>(this IReloaderPrototype<T> source, Func<T, string> check)
        {
            return new CheckInputPropertyPrototype<T>(source, check);
        }
    }
}
