﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using Microsoft.VisualStudio.TestTools.UnitTesting;
using Property.Objects;
using System;
using System.Collections.Generic;

namespace Property.Test.Objects
{
    [TestClass]
    public class CallPropertyPrototypeTest : DelegatePropertyPrototypeTestInfrastructure<object>
    {
        private readonly object _TestValue = new object();
        protected override object TestValue
        {
            get { return _TestValue; }
        }

        [TestMethod]
        public void CommandPropertyReloadTest()
        {
            var sutProperty = new CallPropertyPrototype<object>(
                        ReloaderPrototypeMock.Object, GetValueParameterized)
                        .Create(null);

            SetupEvents(sutProperty);

            Assert.AreEqual(default(object), sutProperty.Value);
            Assert.AreEqual(default(object), sutProperty.DebugValue);
            Assert.AreEqual(default(bool), sutProperty.IsLoading);

            sutProperty.Go();

            Assert.AreEqual(TestValue, sutProperty.Value);
            Assert.AreEqual(TestValue, sutProperty.DebugValue);
            Assert.AreEqual(TestStatus, sutProperty.IsLoading);

            VerifyEvents();
            VerifyReload();
        }
    }
}
