﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using Microsoft.VisualStudio.TestTools.UnitTesting;
using Property.Objects;
using System.Collections.Generic;

namespace Property.Test.Objects
{
    [TestClass]
    public class InputPropertyPrototypeTest : PropertyPrototypeTestInfrastructure<object>
    {
        protected override IEnumerable<string> TestEventStrings
        { get { return new[] { 
            "Changing'Input'", 
            "Changed'Input'", 
            "Changing'IsLoading'", 
            "Changed'IsLoading'", 
            "Changing'Value'", 
            "Changed'Value'" }; } }

        [TestMethod]
        public void InputPropertyReloadTest()
        {
            var testValue = new object();

            var sutProperty = new InputPropertyPrototype<object>(
                        ReloaderPrototypeMock.Object).Create(null);

            SetupEvents(sutProperty);

            Assert.AreEqual(default(object), sutProperty.Input);
            Assert.AreEqual(default(object), sutProperty.Value);
            Assert.AreEqual(default(object), sutProperty.DebugValue);
            Assert.AreEqual(default(bool), sutProperty.IsLoading);

            sutProperty.Input = testValue;

            Assert.AreEqual(testValue, sutProperty.Value);
            Assert.AreEqual(testValue, sutProperty.DebugValue);
            Assert.AreEqual(TestStatus, sutProperty.IsLoading);

            VerifyEvents();
            VerifyReload();
        }
    }
}
