﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Property.Objects;

namespace Property.Test.Objects
{
    [TestClass]
    public class PropertyPrototypeTest : PropertyPrototypeTestInfrastructure<object>
    {
        [TestMethod]
        [ExpectedException(typeof(ArgumentNullException))]
        public void PropertyNullReloaderPrototypeTest()
        {
            new GetPropertyPrototype<object>(
                        null, o => null)
                        .Create(null);
        }

        [TestMethod]
        [ExpectedException(typeof(NotSupportedException))]
        public void PropertyNullReloaderTest()
        {
            new GetPropertyPrototype<object>(
                        NullReloaderPrototypeMock.Object, o => null)
                        .Create(null);
        }

        [TestMethod]
        public void PropertyDisposeTest()
        {
            new GetPropertyPrototype<object>(
                        ReloaderPrototypeMock.Object, o => null)
                        .Create(null).Dispose();

            VerifyDispose();
        }
    }
}
