﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Property.Reloaders;

namespace Property.Test.Reloaders
{
    [TestClass]
    public class ReloaderDecoratorPrototypeTest : ReloaderDecoratorPrototypeTestInfrastructure<object>
    {
        [TestMethod]
        [ExpectedException(typeof(ArgumentNullException))]
        public void ReloaderDecoratorNullReloaderPrototypeTest()
        {
            new ConditionReloaderDecoratorPrototype<object>(null, ()=> true)
                .Create(() => null, _ => { }, __ => { });
        }

        [TestMethod]
        [ExpectedException(typeof(NotSupportedException))]
        public void ReloaderDecoratorNullReloaderTest()
        {
            new ConditionReloaderDecoratorPrototype<object>(NullReloaderPrototypeMock.Object, () => true)
                .Create(() => null, _ => { }, __ => { });
        }

        [TestMethod]
        public void ReloaderDecoratorDisposeTest()
        {
            new ConditionReloaderDecoratorPrototype<object>(ReloaderPrototypeMock.Object, () => true)
                .Create(() => null, _ => { }, __ => { }).Dispose();

            VerifyDispose();
        }
    }
}
