﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System.Linq;
using System;
using Property;
using System.Windows.Input;

namespace Showcase.LoadByWire
{
    // Allows you to start and stop processes by using the respective two commands.
    // Start method does nothing if the process is running and Stop does nothing if it's not.
    public class Actuator
    {
        public Actuator()
        {
            var powerSwitch = Reloadable<bool>.On().Each().Call(o => !o).Create();

            _Power = powerSwitch;
            _Start = () => { if (!powerSwitch.Value)powerSwitch.Go(); };
            _Stop = () => { if (powerSwitch.Value)powerSwitch.Go(); };
        }

        //=//

        // Start 
        private readonly Action _Start;
        public void Start() { _Start(); }

        // Stop 
        private readonly Action _Stop;
        public void Stop() { _Stop(); }

        // Holding switch
        private readonly IProperty<bool> _Power;
        public IProperty<bool> Power { get { return _Power; } }
    }
}
