﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;

namespace Property.Reloaders
{
    public partial class ThrottleReloaderDecoratorPrototype<T> : ReloaderDecoratorPrototype<T>
    {
        public ThrottleReloaderDecoratorPrototype(IReloaderPrototype<T> compositionBasePrototype, ITimerPrototype timerPrototype)
            : base(compositionBasePrototype)
        {
            _TimerPrototype = timerPrototype;
        }

        //=//

        private readonly ITimerPrototype _TimerPrototype;

        public override IReloader Create(Func<T> getValue, Action<T> applyValue, Action<bool> applyStatus)
        {
            return new DecoratorInstance(_CompositionBasePrototype, getValue, applyValue, applyStatus, _TimerPrototype);
        }
    }
}
