﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Property.Timers;
using System.Windows.Threading;

namespace Property.Test.Timers
{
    [TestClass]
    public class DispatcherTimerPrototypeTest : TimerPrototypeTestInfrastructure
    {
        [TestMethod]
        public void DispatcherTimerCreateTest()
        {
            // DispatcherTimerPrototype is only used to provide a mockable 
            // unified Timer interface. System.Windows.Threading.DispatcherTimerPrototype
            // is supported by Microsoft.
            var sutTimer = new DispatcherTimerPrototype(TestTimeSpan).Create();
            Assert.IsInstanceOfType(sutTimer, typeof(DispatcherTimer));
            Assert.IsInstanceOfType(sutTimer, typeof(ITimer));
            Assert.AreEqual(TestTimeSpan, sutTimer.Interval);
            // Dispose() is only present in the wrapper class for compatibility
            // with ITimer.
            sutTimer.Dispose();
        }
    }
}
