﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Property.Timers;
using System.Windows.Forms;

namespace Property.Test.Timers
{
    [TestClass]
    public class WindowsFormsTimerPrototypeTest : TimerPrototypeTestInfrastructure
    {
        [TestMethod]
        public void WindowsFormsTimerCreateTest()
        {
            // WindowsFormsTimerPrototype is only used to provide a mockable 
            // unified Timer interface. System.Windows.Forms.Timer is supported by Microsoft.
            var sutTimer = new WindowsFormsTimerPrototype(TestTimeSpan).Create();
            Assert.IsInstanceOfType(sutTimer, typeof(Timer));
            Assert.IsInstanceOfType(sutTimer, typeof(ITimer));
            Assert.AreEqual(TestTimeSpan, sutTimer.Interval);
        }
    }
}
