﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Property.Reloaders;

namespace Property.Test.Reloaders
{
    [TestClass]
    public class StateConditionReloaderDecoratorPrototypeTest : ReloaderDecoratorPrototypeTestInfrastructure<object>
    {
        [TestMethod]
        public void StateConditionReloaderDecoratorPrototypeReloadTest()
        {
            var sutDecorator = new StateConditionReloaderDecoratorPrototype<object, bool>(ReloaderPrototypeMock.Object, o => true, o => !o)
                .Create(() => null, _ => { }, __ => { });
            sutDecorator.Go();
            VerifyReload(1);
            sutDecorator.Go();
            VerifyReload(1);
        }

        [TestMethod]
        [ExpectedException(typeof(ArgumentNullException))]
        public void StateConditionReloaderDecoratorPrototypeNullGetConditionTest()
        {
            new StateConditionReloaderDecoratorPrototype<object, bool>(ReloaderPrototypeMock.Object, null, o => o)
                .Create(() => null, _ => { }, __ => { });
        }

        [TestMethod]
        [ExpectedException(typeof(ArgumentNullException))]
        public void StateConditionReloaderDecoratorPrototypeNullConditionTest()
        {
            new StateConditionReloaderDecoratorPrototype<object, bool>(ReloaderPrototypeMock.Object, o => o, null)
                .Create(() => null, _ => { }, __ => { });
        }
    }
}
