﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Property.Sequences;
using System.Collections.Generic;

namespace Property.Test.Sequences
{
    [TestClass]
    public class DelegateSequenceConveyorDecoratorTest : SequenceConveyorDecoratorTestInfrastructure<object>
    {
        protected override IEnumerable<string> TestMethodCallStrings
        { get { return new[] { "ModifySequence" }; } }

        [TestMethod]
        public void DelegateSequenceConveyorDecoratorCreateTest()
        {
            var sutConveyorDecorator = new DelegateSequenceConveyorDecorator<object>(SequenceConveyorMock.Object, ModifySequence);

            var result = sutConveyorDecorator.Create(GetValue);

            Assert.AreEqual(SequenceMock.Object, result);

            VerifyCreate();
        }

        [TestMethod]
        [ExpectedException(typeof(ArgumentNullException))]
        public void SourceSequenceConveyorNullModificationTest()
        {
            new DelegateSequenceConveyorDecorator<object>(SequenceConveyorMock.Object, null).Create(GetValue);
        }
    }
}
