﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using Moq;
using System;

namespace Property.Test
{
    public abstract class SequenceConveyorDecoratorTestInfrastructure<T> : SequenceConveyorTestInfrastructure<T>
    {
        private Mock<ISequenceConveyor<T>> SequenceConveyorMockState;
        protected Mock<ISequenceConveyor<T>> SequenceConveyorMock
        {
            get
            {
                if (SequenceConveyorMockState == null)
                {
                    SequenceConveyorMockState = new Mock<ISequenceConveyor<T>>(MockBehavior.Strict);
                    SequenceConveyorMockState
                        .Setup(o => o.Create(It.IsAny<Func<T>>()))
                        .Returns(SequenceMock.Object);
                }
                return SequenceConveyorMockState;
            }
        }

        protected override void VerifyCreate()
        {
            base.VerifyCreate();
            SequenceConveyorMock.Verify(o => o.Create(It.IsAny<Func<T>>()), Times.Once());
        }
    }
}
