﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;

namespace Property.Test
{
    public abstract class CheckPropertyPrototypeTestInfrastructure<T> : PropertyPrototypeTestInfrastructure<T>
    {
        private string ResultErrorString;

        protected virtual string TestErrorString { get { return "Error"; } }


        protected void SetupCheck<TProperty>(TProperty sutProperty, string propertyName) 
            where TProperty : INotifyPropertyChanged, IDataErrorInfo
        {
            sutProperty.PropertyChanged += (o, e) =>
            {
                if (e.PropertyName == "Error" && sutProperty[propertyName] == sutProperty.Error)
                    ResultErrorString = sutProperty[propertyName];
            };
        }

        //=//

        protected void VerifyCheck()
        {
            if (ResultErrorString != TestErrorString) throw new Exception();
        }

    }
}
