﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using System.Globalization;
using System.Windows.Data;

namespace Showcase.LoadByWire
{
    public class LoadingStatusConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var status = (LoadingStatus)value;

            switch (status)
            {
                case LoadingStatus.NoActivity:
                    return "";
                case LoadingStatus.InProcess:
                    return "Loading...";
                case LoadingStatus.EmptyResultSet:
                    return "No employee data records found.";
                case LoadingStatus.RecordsFound:
                    return "1 employee data record(s) found.";
                default:
                    return "";
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
