﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

namespace Property
{
    /// <summary>
    /// The described property of type T ...
    /// </summary>
    /// <typeparam name="T">Desired property type.</typeparam>
    public abstract class Reloadable<T>
    {
        private class Instance : Reloadable<T> { }

        /// <summary>
        /// ... will reload ...
        /// </summary>
        public static Reloadable<T> On() 
        {
            return new Instance();
        }
    }
}
