﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Property.Subscriptions;

namespace Property.Test.Chains
{
    [TestClass]
    public class SubscriptionTest : SubscriptionTestInfrastructure<object>
    {
        [TestMethod]
        [ExpectedException(typeof(ArgumentNullException))]
        public void SubscriptionNullPropertyTest()
        {
            new ChangedActionSubscription<object>(null, () => { });
        }

        [TestMethod]
        public void SubscriptionDisposeTest()
        {
            IDisposable sutSubscription = new ChangedActionSubscription<object>(PropertyMock.Object, () => TargetMock.Object.Go());
            var reference = new WeakReference(sutSubscription, true);

            sutSubscription.Dispose();
            sutSubscription = null;
            GC.Collect();

            Assert.IsNull(reference.Target);
        }
    }
}
