﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;

namespace Property.Workers
{
    public partial class RetryFunctionWorkerDecoratorPrototype<T> : FunctionWorkerDecoratorPrototype<T>, IFunctionWorkerPrototype<T>
    {
        public RetryFunctionWorkerDecoratorPrototype(IFunctionWorkerPrototype<T> compositionBasePrototype, int retryCount)
            : base(compositionBasePrototype)
        {
            _RetryCount = retryCount;
        }

        //=//

        private readonly int _RetryCount;

        public override IWorker Create(Func<T> getValue)
        {
            return new DecoratorInstance(_CompositionBasePrototype, getValue, _RetryCount);
        }
    }
}
