﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;

namespace Property.Reloaders
{
    public partial class StateConditionReloaderDecoratorPrototype<T, TState> : ReloaderDecoratorPrototype<T>
    {
        public StateConditionReloaderDecoratorPrototype(IReloaderPrototype<T> compositionBasePrototype, Func<TState, TState> getConditionState, Func<TState, bool> condition)
            : base(compositionBasePrototype)
        {
            _GetConditionState = getConditionState;
            _Condition = condition;
        }

        //=//

        private readonly Func<TState, TState> _GetConditionState;
        private readonly Func<TState, bool> _Condition;

        public override IReloader Create(Func<T> getValue, Action<T> applyValue, Action<bool> applyStatus)
        {
            return new DecoratorInstance(_CompositionBasePrototype, getValue, applyValue, applyStatus, _GetConditionState, _Condition);
        }
    }
}
