﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;

namespace Property.Reloaders
{
    public partial class FilterReloaderDecoratorPrototype<T> : ReloaderDecoratorPrototype<T>
    {
        public FilterReloaderDecoratorPrototype(IReloaderPrototype<T> compositionBasePrototype, Func<IObservable<object>, IObservable<object>> filter)
            : base(compositionBasePrototype)
        {
            _Filter = filter;
        }

        //=//

        private readonly Func<IObservable<object>, IObservable<object>> _Filter;

        public override IReloader Create(Func<T> getValue, Action<T> applyValue, Action<bool> applyStatus)
        {
            return new DecoratorInstance(_CompositionBasePrototype, getValue, applyValue, applyStatus, _Filter);
        }
    }
}
