﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;

namespace Property.Sequences
{
    public abstract class SequenceConveyorDecorator<T> : SequenceConveyor<T>
    {
        protected SequenceConveyorDecorator(ISequenceConveyor<T> compositionBaseConveyor)
        {
            if (compositionBaseConveyor == null) throw new ArgumentNullException("compositionBaseConveyor");

            _CompositionBaseConveyor = compositionBaseConveyor;
        }

        //=//

        protected readonly ISequenceConveyor<T> _CompositionBaseConveyor;
    }
}
