﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using Microsoft.VisualStudio.TestPlatform.UnitTestFramework;
using Property.Subscriptions;
using System.ComponentModel;

namespace Property.Test.Chains
{
    [TestClass]
    public class ChangedActionSubscriptionTest : SubscriptionTestInfrastructure<object>
    {
        private bool TestIsLoadingState;
        protected override bool TestIsLoading { get { return TestIsLoadingState; } }

        [TestMethod]
        public void ChangedActionSubscriptionCallTest()
        {
            SetupCall();

            using (new ChangedActionSubscription<object>(PropertyMock.Object, () => TargetMock.Object.Go()))
            {
                TestIsLoadingState = false;
                PropertyMock.Raise(o => o.PropertyChanging += null, new PropertyChangingEventArgs("IsLoading"));
                PropertyMock.Raise(o => o.PropertyChanged += null, new PropertyChangedEventArgs("IsLoading"));
                TestIsLoadingState = true;
                PropertyMock.Raise(o => o.PropertyChanging += null, new PropertyChangingEventArgs("IsLoading"));
                PropertyMock.Raise(o => o.PropertyChanged += null, new PropertyChangedEventArgs("IsLoading"));
                PropertyMock.Raise(o => o.PropertyChanging += null, new PropertyChangingEventArgs("Value"));
                PropertyMock.Raise(o => o.PropertyChanged += null, new PropertyChangedEventArgs("Value"));
            }
            
            VerifyCall();
        }
    }
}
