﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using Moq;

namespace Property.Test
{
    public abstract class SubscriptionTestInfrastructure<T>
    {
        protected virtual bool TestIsLoading { get { return false; } }

        private Mock<IProperty<T>> PropertyMockState;
        protected Mock<IProperty<T>> PropertyMock
        {
            get
            {
                if (PropertyMockState == null)
                {
                    PropertyMockState = new Mock<IProperty<T>>(MockBehavior.Strict);
                    PropertyMockState.Setup(o => o.IsLoading).Returns(() => TestIsLoading);
                }
                return PropertyMockState;
            }
        }

        private Mock<ICallDriven> TargetMockState;
        protected Mock<ICallDriven> TargetMock
        {
            get
            {
                return TargetMockState ??
                    (TargetMockState = new Mock<ICallDriven>(MockBehavior.Strict));
            }
        }

        protected void SetupCall()
        {
            TargetMock.Setup(o => o.Go());
        }

        //=//

        protected void VerifyCall()
        {
            TargetMock.Verify(o => o.Go(), Times.Once());
        }
    }
}
