﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using Microsoft.VisualStudio.TestPlatform.UnitTestFramework;
using Property.Objects;

namespace Property.Test.Objects
{
    [TestClass]
    public class PropertyPrototypeTest : PropertyPrototypeTestInfrastructure<object>
    {
        [TestMethod]
        public void PropertyNullReloaderPrototypeTest()
        {
            try
            {
                new GetPropertyPrototype<object>(
                            null, o => null)
                            .Create(null);
            }
            catch (ArgumentException){ return; }
            Assert.Fail();
        }

        [TestMethod]
        public void PropertyNullReloaderTest()
        {
            try
            {
                new GetPropertyPrototype<object>(
                            NullReloaderPrototypeMock.Object, o => null)
                            .Create(null);
            }
            catch (NotSupportedException) { return; }
            Assert.Fail();
        }

        [TestMethod]
        public void PropertyDisposeTest()
        {
            new GetPropertyPrototype<object>(
                        ReloaderPrototypeMock.Object, o => null)
                        .Create(null).Dispose();

            VerifyDispose();
        }
    }
}
