﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using Microsoft.VisualStudio.TestPlatform.UnitTestFramework;
using Property.Reloaders;

namespace Property.Test.Reloaders
{
    [TestClass]
    public class ConditionReloaderDecoratorPrototypeTest : ReloaderDecoratorPrototypeTestInfrastructure<object>
    {
        [TestMethod]
        public void ConditionReloaderDecoratorPrototypeReloadTest()
        {
            var testCondition = true;

            var sutDecorator = new ConditionReloaderDecoratorPrototype<object>(ReloaderPrototypeMock.Object, () => testCondition)
                .Create(() => null, _ => { }, __ => { });
            sutDecorator.Go();
            VerifyReload(1);

            testCondition = false;
            sutDecorator.Go();
            VerifyReload(1);
        }

        [TestMethod]
        public void ConditionReloaderDecoratorPrototypeNullConditionTest()
        {
            try
            {
                new ConditionReloaderDecoratorPrototype<object>(ReloaderPrototypeMock.Object, null)
                    .Create(() => null, _ => { }, __ => { });
            }
            catch (ArgumentNullException) { return; }
            Assert.Fail();
        }
    }
}
