﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using Microsoft.VisualStudio.TestPlatform.UnitTestFramework;
using Property.Reloaders;

namespace Property.Test.Reloaders
{
    [TestClass]
    public class ReloaderDecoratorPrototypeTest : ReloaderDecoratorPrototypeTestInfrastructure<object>
    {
        [TestMethod]
        public void ReloaderDecoratorNullReloaderPrototypeTest()
        {
            try
            {
                new ConditionReloaderDecoratorPrototype<object>(null, () => true)
                    .Create(() => null, _ => { }, __ => { });
            }
            catch (ArgumentNullException) { return; }
            Assert.Fail();
        }

        [TestMethod]
        public void ReloaderDecoratorNullReloaderTest()
        {
            try
            {
                new ConditionReloaderDecoratorPrototype<object>(NullReloaderPrototypeMock.Object, () => true)
                    .Create(() => null, _ => { }, __ => { });
            }
            catch (NotSupportedException) { return; }
            Assert.Fail();
        }

        [TestMethod]
        public void ReloaderDecoratorDisposeTest()
        {
            new ConditionReloaderDecoratorPrototype<object>(ReloaderPrototypeMock.Object, () => true)
                .Create(() => null, _ => { }, __ => { }).Dispose();

            VerifyDispose();
        }
    }
}
