﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using Microsoft.VisualStudio.TestPlatform.UnitTestFramework;
using Property.Reloaders;

namespace Property.Test.Reloaders
{
    [TestClass]
    public class StateConditionReloaderDecoratorPrototypeTest : ReloaderDecoratorPrototypeTestInfrastructure<object>
    {
        [TestMethod]
        public void StateConditionReloaderDecoratorPrototypeReloadTest()
        {
            var sutDecorator = new StateConditionReloaderDecoratorPrototype<object, bool>(ReloaderPrototypeMock.Object, o => true, o => !o)
                .Create(() => null, _ => { }, __ => { });
            sutDecorator.Go();
            VerifyReload(1);
            sutDecorator.Go();
            VerifyReload(1);
        }

        [TestMethod]
        public void StateConditionReloaderDecoratorPrototypeNullGetConditionTest()
        {
            try
            {
                new StateConditionReloaderDecoratorPrototype<object, bool>(ReloaderPrototypeMock.Object, null, o => o)
                    .Create(() => null, _ => { }, __ => { });
            }
            catch (ArgumentNullException) { return; }
            Assert.Fail();
        }

        [TestMethod]
        public void StateConditionReloaderDecoratorPrototypeNullConditionTest()
        {
            try
            {
                new StateConditionReloaderDecoratorPrototype<object, bool>(ReloaderPrototypeMock.Object, o => o, null)
                    .Create(() => null, _ => { }, __ => { });
            }
            catch (ArgumentNullException) { return; }
            Assert.Fail();
        }
    }
}
