﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using System.Linq;
using Microsoft.VisualStudio.TestPlatform.UnitTestFramework;
using Property.Sequences;

namespace Property.Test.Sequences
{
    [TestClass]
    public class SourceSequenceConveyorTest : SequenceConveyorTestInfrastructure<object>
    {
        [TestMethod]
        public void SourceSequenceConveyorCreateTest()
        {
            var sutConveyor = new SourceSequenceConveyor<object>(GetSequence);

            var result = sutConveyor.Create(GetValue);

            Assert.AreEqual(SequenceMock.Object, result);

            VerifyCreate();
        }

        [TestMethod]
        public void SourceSequenceConveyorNullGetSequenceTest()
        {
            try
            {
                new SourceSequenceConveyor<object>(null).Create(GetValue);
            }
            catch (ArgumentNullException) { return; }
            Assert.Fail();
        }

        [TestMethod]
        public void SourceSequenceConveyorNullGetValueTest()
        {
            var sequence = new SourceSequenceConveyor<object>(GetSequence).Create(null);
            Assert.IsNull(sequence);
        }
    }
}
