﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;

namespace Property.Test
{
    public abstract class ValidationPropertyPrototypeTestInfrastructure<T> : PropertyPrototypeTestInfrastructure<T>
    {
        private IEnumerable<string> ResultErrorStrings;

        protected virtual IEnumerable<string> TestErrorStrings
        { get { return new[] { "Error1", "Error2" }; } }


        protected void SetupValidation(INotifyDataErrorInfo sutProperty, string propertyName)
        {
            sutProperty.ErrorsChanged += (o, e) =>
            {
                if (e.PropertyName == propertyName && sutProperty.HasErrors)
                    ResultErrorStrings = sutProperty.GetErrors(propertyName).Cast<string>();
            };
        }

        //=//

        protected void VerifyValidation()
        {
            new[] { ResultErrorStrings.SequenceEqual(TestErrorStrings) }
                .Where(o => !o)
                .ToList()
                .ForEach(o => { throw new Exception(); });
        }
    }
}
