﻿// Copyright (c) Vitaly Kamiansky. All rights reserved. 
// See License.txt in the project root.

namespace Showcase.LoadByWire
{
    public class Employee
    {
        public Employee(int id, string passportNr, string firstName, string lastName, string company, string email)
        {
            _Id = id;
            _PassportNr = passportNr;
            _FirstName = firstName;
            _LastName = lastName;
            _Company = company;
            _Email = email;
        }

        //=//

        private readonly int _Id;
        public int Id { get { return _Id; } }

        private readonly string _PassportNr;
        public string PassportNr { get { return _PassportNr; } }

        private readonly string _FirstName;
        public string FirstName { get { return _FirstName; } }

        private readonly string _LastName;
        public string LastName { get { return _LastName; } }

        private readonly string _Company;
        public string Company { get { return _Company; } }

        private readonly string _Email;
        public string Email { get { return _Email; } }

        //=//

        public override bool Equals(object obj)
        {
            var operand = obj as Employee;
            if (operand == null) return false;

            return (operand.Id == _Id)
                && (operand.PassportNr == _PassportNr)
                && (operand.Company == _Company)
                && (operand.Email == _Email)
                && (operand.FirstName == _FirstName)
                && (operand.LastName == _LastName);
        }

        public override int GetHashCode()
        {
            int hash = 23;
            hash = hash * 37 + _Id.GetHashCode();
            hash = hash * 37 + _PassportNr.GetHashCode();
            hash = hash * 37 + _Company.GetHashCode();
            hash = hash * 37 + _Email.GetHashCode();
            hash = hash * 37 + _FirstName.GetHashCode();
            hash = hash * 37 + _LastName.GetHashCode();
            return hash;
        }
    }
}
